package com.finotes.flutter.finotescore;

import android.app.Application;
import android.content.Context;
import android.os.Build;
import android.util.Log;

import androidx.annotation.NonNull;

import java.util.ArrayList;
import java.util.HashMap;

import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;

/** FinotescorePlugin */
public class FinotescorePlugin implements FlutterPlugin, MethodCallHandler {
  /// The MethodChannel that will the communication between Flutter and native Android
  ///
  /// This local reference serves to register the plugin with the Flutter Engine and unregister it
  /// when the Flutter Engine is detached from the Activity
  private MethodChannel channel;
  private Context context;

  @Override
  public void onAttachedToEngine(@NonNull FlutterPluginBinding flutterPluginBinding) {
    channel = new MethodChannel(flutterPluginBinding.getBinaryMessenger(), "finotescore");
    channel.setMethodCallHandler(this);
    context = flutterPluginBinding.getApplicationContext();
  }

  @Override
  public void onMethodCall(@NonNull MethodCall call, @NonNull Result result) {

    if (call.method.equals("init")) {
      com.finotes.android.finotescore.Fn.init((Application) context);
      result.success(1);
    }else if (call.method.equals("log")) {
      com.finotes.android.finotescore.Fn.log();
      result.success(1);
    }else if (call.method.equals("customIssue")) {
      ArrayList<String> argumentsList = call.arguments();
      com.finotes.android.finotescore.Fn.reportIssue(argumentsList.get(0), argumentsList.get(1), argumentsList.get(2));
      result.success(1);
    }else if (call.method.equals("buildCrashIssue")) {
      ArrayList<String> argumentsList = call.arguments();
      com.finotes.android.finotescore.Fn.buildCrashIssue(argumentsList.get(0),argumentsList.get(1),argumentsList.get(2),argumentsList.get(3));
      result.success(1);
    }else if (call.method.equals("buildException")) {
      ArrayList<String> argumentsList = call.arguments();
      com.finotes.android.finotescore.Fn.buildException(argumentsList.get(0),argumentsList.get(1),argumentsList.get(2),argumentsList.get(3));
      result.success(1);
    }else if (call.method.equals("setActivityMarker")) {
      ArrayList<String> argumentsList = call.arguments();
      com.finotes.android.finotescore.Fn.setActivityMarker(argumentsList.get(0), argumentsList.get(1));
      result.success(1);
    }else if (call.method.equals("getSdkInt")) {
      result.success(Build.VERSION.SDK_INT);
    }else if (call.method.equals("flutterMainIsolatePush")) {
      ArrayList<String> argumentsList = call.arguments();
      com.finotes.android.finotescore.Fn.flutterMainIsolatePush(argumentsList.get(0));
      result.success(1);
    } else {
      result.notImplemented();
    }
  }

  @Override
  public void onDetachedFromEngine(@NonNull FlutterPluginBinding binding) {
    channel.setMethodCallHandler(null);
  }
}
